Commit | Line | Data |
---|---|---|
dd7a064c NC |
1 | #!/bin/bash |
2 | # | |
3 | # Copyright 2010 Ericsson AB | |
4 | # | |
5 | # This file is part of LTTng-UST. | |
6 | # | |
7 | # LTTng-UST is free software: you can redistribute it and/or modify | |
8 | # it under the terms of the GNU General Public License as published by | |
9 | # the Free Software Foundation, either version 3 of the License, or | |
10 | # (at your option) any later version. | |
11 | # | |
12 | # LTTng-UST is distributed in the hope that it will be useful, | |
13 | # but WITHOUT ANY WARRANTY; without even the implied warranty of | |
14 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the | |
15 | # GNU General Public License for more details. | |
16 | # | |
17 | # You should have received a copy of the GNU General Public License | |
18 | # along with LTTng-UST. If not, see <http://www.gnu.org/licenses/>. | |
19 | ||
20 | TESTDIR=$(dirname $0) | |
21 | ||
22 | source $TESTDIR/test_functions.sh | |
23 | source $TESTDIR/tap.sh | |
24 | ||
9dc7b7ff | 25 | starttest "ust-consumerd valgrind check" |
dd7a064c | 26 | |
4007533b | 27 | if ! which valgrind > /dev/null; then |
a4e9613d | 28 | echo "$0: Valgrind not found on the system." 1>&2 |
4007533b YB |
29 | exit 1; |
30 | fi | |
31 | ||
dd7a064c NC |
32 | plan_tests 2 |
33 | ||
4007533b | 34 | TRACE_DIR="/tmp/ust-testsuite-$USER-ust-consumerdvalgrind-trace" |
dd7a064c NC |
35 | rm -rf "$TRACE_DIR" |
36 | mkdir "$TRACE_DIR" | |
37 | ||
9dc7b7ff | 38 | pidfilepath="/tmp/ust-testsuite-$USER-$(date +%Y%m%d%H%M%S%N)-ust-consumerd-pid" |
dd7a064c NC |
39 | mkfifo -m 0600 "$pidfilepath" |
40 | ||
4007533b YB |
41 | UST_CONSUMERD="$TESTDIR/../ust-consumerd/.libs/ust-consumerd" |
42 | USTTRACE="$TESTDIR/../usttrace" | |
43 | ||
44 | VALG_OUT=/tmp/ust-testsuite-$USER-valg.txt | |
45 | export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$TESTDIR/../libustconsumer/.libs/" | |
46 | valgrind --suppressions=$TESTDIR/valgrind_suppress.txt -q $UST_CONSUMERD --pidfile "$pidfilepath" -o "$TRACE_DIR" >/dev/null 2>"$VALG_OUT" & | |
dd7a064c | 47 | VALG_PID=$! |
18cc44ca NC |
48 | |
49 | # Paranoid check that valgrind is alive or we will hang forever on the fifo | |
50 | if ! ps $VALG_PID > /dev/null; then | |
51 | echo "Valgrind appears to have died, giving up" | |
52 | rm $pidfilepath | |
53 | exit | |
54 | fi | |
55 | ||
9dc7b7ff | 56 | UST_CONSUMERD_PID="$(<$pidfilepath)" |
dd7a064c | 57 | |
4007533b | 58 | okx $USTTRACE -L -s $TESTDIR/basic/.libs/basic |
dd7a064c | 59 | |
37b70e91 | 60 | kill -SIGTERM ${UST_CONSUMERD_PID} |
dd7a064c NC |
61 | wait $! |
62 | ||
63 | echo "Valgrind output is in $VALG_OUT" | |
64 | if [ -z "$(<$VALG_OUT)" ]; then | |
9dc7b7ff | 65 | pass "Valgrind found no errors in ust-consumerd" |
dd7a064c | 66 | else |
9dc7b7ff | 67 | fail "Valgrind found errors in ust-consumerd:" |
dd7a064c | 68 | cat $VALG_OUT | while read; do |
4007533b | 69 | diag "$REPLY" |
dd7a064c NC |
70 | done |
71 | fi | |
18cc44ca NC |
72 | |
73 | rm $pidfilepath |